define('smart-attachments/AsyncModule', ['jquery'], function ($) {
    if (!window.SmartAttachment) {
        window.SmartAttachment = {};
    }

    if (!window.SmartAttachment.AsyncModule) {
        function AsyncModule() {
            this.modules = {};
        }

        _.extend(AsyncModule.prototype, {
            getCallback: function (name) {
                var deferred = this.modules[name];
                if (typeof deferred === 'undefined') {
                    console.log('Wait module: ' + name);
                    deferred = $.Deferred();
                    this.modules[name] = deferred;
                }
                return deferred;
            },

            resolveModule: function (name) {
                console.log('Resolve module: ' + name);
                var deferred = this.getCallback(name);
                deferred.resolve({});
            },

            onReady: function (name, callback) {
                this.getCallback(name).then(callback);
            }
        });

        window.SmartAttachment.AsyncModule = new AsyncModule();
    }

    return window.SmartAttachment.AsyncModule;
});

require(['jquery', 'smart-attachments/AsyncModule'], function ($, AsyncModule) {
    function isGlobalObjectExists(path) {
        var names = path.split('.');
        var current = window;
        var stop = false;
        for (var i = 0; i < names.length && !stop; i++) {
            current = current[names[i]];
            stop = !current;
        }
        return !stop && i === names.length;
    }

    var $document = $(document);
    function modifyFunction(owner, method) {
        var originalMethod = owner[method];
        if (originalMethod) {
           owner[method]= function (e, d) {
                var result = originalMethod.apply(this, arguments);
                if (e === 'globalEventClick') {
                    if (result.obtainFileIdentifierFromDom) {
                        result.obtainFileIdentifierFromDom();
                    }
                }
                return result;
            };
        }
    }
    $document.on('goedit:initialized', function () {
        if (isGlobalObjectExists('GoEdit.Container.GoEditLinkRenderer')) {
            modifyFunction(GoEdit.Container.GoEditLinkRenderer, 'getJiraLinkInitialiserForGlobalEvent');
        } else if (isGlobalObjectExists('GoEdit.Container.GoEditIntegration')){
            modifyFunction(GoEdit.Container.GoEditIntegration, 'getJiraLinkRepresentationForGlobalEvent');
        }
        AsyncModule.resolveModule('goedit');
    });
});