(function($) {

    window.SmartAttachAutocomplete = {
        pattern: '',

        init: function($textarea) {
            if ($.browser.msie  && parseInt($.browser.version, 10) <= 8) {
                return;
            }

            var t = this;
            t.pattern = new Cursores(new RegExp('(?:^|,\\s)(.[^.,\\s~]*)'));
            $(document).click(function() {
                t.removeSuggestions();
            });

            t.bindTextAreaEvents($textarea);
        },

        bindTextAreaEvents: function($textarea) {
            this.bindTextAreaSuggestionsNavigation($textarea);
            this.bindTextAreaAutocomplete($textarea);
        },

        bindTextAreaSuggestionsNavigation: function($textarea) {
            $textarea.keydown(function(e) {
                var $suggestions = $('.smart-attach-suggestions');
                if ($suggestions.length > 0) {
                    if ($.inArray(e.which, [13, 27, 38, 40]) >= 0) {
                        e.preventDefault();
                        e.stopPropagation();
                    }

                    // Enter
                    if (e.which == 13) {
                        $('.smart-attach-suggestion-active').find('.smart-attach-suggestion').click();
                    }

                    // Escape
                    if (e.which == 27) {
                        $suggestions.remove();
                    }

                    // Up
                    if (e.which == 38) {
                        var $prev = $('.smart-attach-suggestion-active').removeClass('smart-attach-suggestion-active').prev('li');
                        if ($prev.length == 0) {
                            $prev = $suggestions.find("li:last");
                        }
                        $prev.addClass("smart-attach-suggestion-active");
                    }

                    // Down
                    if (e.which == 40) {
                        var $next = $('.smart-attach-suggestion-active').removeClass('smart-attach-suggestion-active').next('li');
                        if ($next.length == 0) {
                            $next = $suggestions.find("li:first");
                        }
                        $next.addClass("smart-attach-suggestion-active");
                    }
                }
            });
        },

        bindTextAreaAutocomplete: function($textarea) {
            var t = this;

            $textarea.keyup(function(e) {
                if ($.inArray(e.which, [13, 38, 40]) >= 0) {
                    return;
                }

                var token = t.pattern.token($textarea[0]);

                if (token.value.length > 0) {
                    t.showSuggestions($textarea, token);
                } else {
                    t.removeSuggestions();
                }
            });
        },

        bindSuggestionEvent: function($textarea, suggestions) {
            var t = this;

            suggestions.click(function() {
                var $suggestion = $('.smart-attach-suggestion', this);
                if ($suggestion.length > 0) {
                    var text = $suggestion.attr('data-mail');
                    t.pattern.replace($textarea[0], text);
                    t.removeSuggestions();
                    $textarea.focus();
                }
                return false;
            });

            suggestions.hover(function() {
                $('.smart-attach-suggestion-active').removeClass('smart-attach-suggestion-active');
                $(this).addClass('smart-attach-suggestion-active');
            }, function() {
            });
        },

        showSuggestions: function($textarea, token) {
            var t = this;

            $.ajax({
                type: 'GET',
                cache: false,
                url: AJS.params.baseURL + "/rest/api/2/user/viewissue/search",
                data: {
                    issueKey: AttachCat.getIssueKey(),
                    projectKey: AttachCat.getProjectKey(),
                    maxResults: 7,
                    username: token.value
                },
                dataType: 'json',
                success: function(users) {
                    $.ajax({
                        type: 'GET',
                        cache: false,
                        url: AJS.params.baseURL + "/rest/attach-cat/1.0/attachments/autocomplete",
                        data: {
                            query: token.value
                        },
                        dataType: 'json',
                        success: function(data) {
                            users = $.merge(users, data.mails);
                            t.removeSuggestions();

                            $('body').append(AttachCategory.suggestions({
                                suggestions: users,
                                query: token.value
                            }));

                            $(".smart-attach-suggestions").css('width', $textarea.innerWidth() + 'px')
                                .offset({
                                    top: $textarea.offset().top + $textarea.outerHeight() + 2,
                                    left: $textarea.offset().left
                                });

                            var suggestions = $('.smart-attach-suggestions li');
                            t.bindSuggestionEvent($textarea, suggestions);

                            $('.smart-attach--suggestions li:first').addClass("smart-attach-suggestion-active");
                        },
                        error: function () {
                            t.removeSuggestions();
                            AJS.log("Unable to find users for query {" + token.value + "}");                                   }
                    });
                }
            });
        },

        removeSuggestions: function() {
            $('.smart-attach-suggestions').remove();
        }
    };

})(AJS.$);