define('smart-attachments/base/DropZoneSection', ['jquery'], function ($) {
    var MARGIN = 10;
    return {
        createSections: function (dropZoneContainer, categoriesContainer, categories, categoryTemplate) {
            var containerWidth = $(dropZoneContainer).width() - MARGIN;
            var containerHeight = $(dropZoneContainer).height() - MARGIN;

            var count = categories.length;
            var columns = Math.ceil(Math.sqrt(count));
            var rows = Math.ceil(count / columns);
            var heightItem = ((containerHeight / rows) * 100) / containerHeight;

            var sum = 0;
            for (var i = 0; i < rows; i++) {
                var amountInRow = Math.ceil((count - sum) / (rows - i));
                var widthItem = ((containerWidth / amountInRow) * 100) / containerWidth;

                for (var j = 0; j < amountInRow; j++) {
                    categoriesContainer.append($(categoryTemplate({
                        category: categories[sum + j],
                        height: heightItem,
                        width: widthItem
                    })));
                }
                sum += amountInRow;
            }
        }
    }
});