define('smart-attachments/base/Functions', [], function () {
    function getDocumentId(element) {
        return getIntFromDataset(element, 'documentId')
    }

    function getDocumentName(element) {
        return element.dataset['documentName'];
    }

    function isDocument(element) {
        var value = element.dataset['document'];
        return (value && value.toLowerCase() === 'true');
    }

    function getIntFromDataset(element, name) {
        var value = element.dataset[name];
        if (value) {
            return parseInt(value);
        }
        return void 0;
    }

    function getAttachmentId(element) {
        return getIntFromDataset(element, 'attachmentId')
    }


    return {
        getAttachmentId: getAttachmentId,
        getDocumentId: getDocumentId,
        getDocumentName: getDocumentName,
        isDocument: isDocument
    }

});