define('smart-attachments/dropzone/FieldTypeDropZone',
    [
        'jquery',
        'underscore',
        'jira/lib/class',
        'smart-attachments/base/CommonClasses'
    ],
    function ($, _, Class, CommonClasses) {
        var FieldTypeDropZone = Class.extend({
            init: function (categories, $form, dropzone, lastCategoryId) {
                dropzone.$node.show();
                var $formFieldGroup = dropzone.$node.parent();
                var selectedCategoryId = lastCategoryId || 0;
                if (categories.length) {
                    this.initDropdownCategories(categories, selectedCategoryId, $form, $formFieldGroup);
                } else {
                    this.getSelectedCategoryId = function() {
                        return selectedCategoryId;
                    }
                }
                this.dropzone = dropzone;
                this.categories = categories;
                $form.prop('_decoratedDropZone', this);
            },

            initDropdownCategories: function (categories, selectedCategoryId, $form, $fileInputList) {
                var $selectBlock = $(AttachCatDialog.catSelect({
                    categories: categories,
                    defaultId: selectedCategoryId
                }));
                $fileInputList.parent().before($selectBlock);
                this.categorySelect = $selectBlock.find('select');
                this.categorySelect.val(selectedCategoryId);
            },

            getDefaultOrFirstCategory: function () {
                var result = _.find(this.categories, function (category) {
                    return category.id === 0;
                });
                if (!result) {
                    result = this.categories[0];
                }
                return result;
            },

            getDefaultOrFirstCategoryDropzone: function () {
                this.dropzone.category = this.getDefaultOrFirstCategory();
                return this.dropzone;
            },

            getProgressBars: function () {
                return this.dropzone.progressBars;
            },

            appendProgressBar: function (progressBar) {

            },

            getSelectedCategoryId: function() {
                if (this.categorySelect) return parseInt(this.categorySelect.val());
                return 0;
            },

            getTempAttachments: function () {
                var selectedCategoryId = this.getSelectedCategoryId();
                return this.dropzone.progressBars.map(function (progressBar) {
                    return new CommonClasses.TempAttachment(progressBar.getFileName(), selectedCategoryId);
                });
            },

            getJiraTempAttachments: function () {
                var selectedCategoryId = this.getSelectedCategoryId();
                return this.dropzone.progressBars.map(function (progressBar) {
                    return new CommonClasses.JiraTempAttachment(progressBar.getFileID(), selectedCategoryId);
                });
            },

            getDropZoneByCategoryId: function (categoryId) {
                var category = _.find(this.categories, function (category) {
                    return category.id === categoryId;
                });

                if (category) {
                    this.dropzone.category = category;
                } else {
                    this.dropzone.category = this.getDefaultOrFirstCategory();
                }
                return category;
            }
        });

        return FieldTypeDropZone;
    });