define('smart-attachments/dropzone/FormDropZone', [
        'jquery',
        'underscore',
        'dndattachment/dropzones/FormDropZone'
    ], function ($, _, FormDropZone) {
        var connectContainer = FormDropZone.prototype.connectContainer;
        var loadAttachments = FormDropZone.prototype.loadAttachments;

        return {
            connect: function () {
                console.log("FormDropZone customized");
                FormDropZone.prototype.connectContainer = function () {
                    console.log('Connect container');
                    connectContainer.apply(this, arguments);
                };

                FormDropZone.prototype.initDropzoneFinished = function() {
                    this.$formNode.prop('_dropzone', this);
                    this.$formNode.trigger('dropzone:connected', [this]);
                };

                FormDropZone.prototype.loadAttachments = function (attachments) {
                    console.log('load attachments');
                    if (attachments.length) {
                        var counter = attachments.length;
                        this.bind('uploadFinished', function() {
                            counter = counter-1;
                            if (!counter) {
                                this.initDropzoneFinished();
                            }
                        }.bind(this));
                    }
                    loadAttachments.apply(this, arguments);
                    if (!attachments.length) {
                        this.initDropzoneFinished();
                    }
                }
            },

            disconnect: function () {
                FormDropZone.prototype.connectContainer = connectContainer;
                FormDropZone.prototype.loadAttachments = loadAttachments;
            }
        }
    }
);