define('smart-attachments/analytics-data', function () {

    var tid = "UA-18056811-33";

    var screens = {
        ISSUE: 'Opening Issue',
        WORKFLOW: 'Workflow Administration',
        PROJECT_SCHEME_ADMINISTRATION: 'Project Scheme Administration',
        GLOBAL_SCHEME_ADMINISTRATION: 'Global Scheme Administration',
        OPENING_FORMS: 'Opening Forms',
    };

    var categories = {
        GLOBAL_SCHEME: 'Global Scheme',
        PROJECT_SCHEME: 'Project Scheme',
        ATTACHMENT_METHOD: 'Attachment Method',
        ATTACHMENT: 'Attachment',
        COMMENT_THREADS: 'Comment Threads',
        ATTACHMENTS: 'Attachments',
        EVENT_ANALYTICS: 'Event Analytics',
        WORKFLOW_CONDITION: 'Workflow Condition',
        WORKFLOW_VALIDATOR: 'Workflow Validator',
        WORKFLOW_POST_FUNCTION: 'Workflow Post Function',
    };

    var actions = {
        SEND_TO_EMAIL: 'Attachment to Email Sending',
        ANALYTICS_ON: 'Analytics Enabled',
        ANALYTICS_OFF: 'Analytics Disabled',
        FILE_UPL_USER_ADD: 'File Uploader User - Adding',
        FILE_UPL_GROUP_ADD: 'File Uploader Group - Adding',
        FILE_UPL_PROJECT_ROLE_ADD: 'File Uploader Project Role - Adding',
        CATEGORY_NOT_EMPTY_ADD: 'Category Not Empty - Adding',
        ATTACH_FROM_CATEGORY_REMOVE: 'Attachment from Category Removal',
        ATTACH_TO_CATEGORY_MOVE: 'Attachment to Category Moving',
        LIMIT_ATT_IN_CATEGORY: 'Limit Attachments in Category - Adding',
        SCHEME_CREATED: 'Scheme Created',
        SCHEME_EDITED: 'Scheme Edited',
        SCHEME_DELETED: 'Scheme Deleted',
        SCHEME_COPIED: 'Scheme Copied',
        SCHEME_ASSOCIATED: 'Scheme Associated',
        SCHEME_DISASSOCIATED: 'Scheme Disassociated',
        SCHEME_SWITCHED: 'Scheme Switched',
        CATEGORY_ADDED: 'Category Added',
        CATEGORY_DELETED: 'Category Deleted',
        CATEGORY_RENAMED: 'Category Renamed',
        CATEGORY_ISSUE_TYPES_APPLIED: 'Category Issue Types Applied',
        CATEGORY_ACCESS_RESTRICTIONS_APPLIED: 'Category Access Restrictions Applied',
        CATEGORY_AUTODISTRIBUTION_RULES_APPLIED: 'Category Autodistribution Rules Applied',
        ATTACHMENT_DRAG_N_DROP_TO_ISSUE: 'Attachment Drag-n-Drop to Issue',
        AGILE_BOARD_DRAG_N_DROP_ATTACHMENT: 'Agile Board - Drag-n-Drop Attachment',
        ISSUE_NAVIGATOR_DRAG_N_DROP_ATTACHMENT: 'Issue Navigator - Drag-n-Drop Attachment',
        SEARCH_FOR_ISSUES_ATTACHMENT_DRAG_N_DROP: 'Search for Issues - Attachment Drag-n-Drop',
        QUEUES_DRAG_N_DROP_ATTACHMENT: 'Queues - Drag-n-Drop Attachment',
        ATTACHMENT_RENAMED: 'Attachment Renamed',
        ATTACHMENT_TO_EMAIL_SENT: 'Attachment to Email Sent',
        ATTACHMENT_TO_CATEGORY_MOVED: 'Attachment to Category Moved',
        ATTACHMENT_WITH_GOEDIT_EDITED: 'Attachment with GoEdit edited',
        BULK_OPERATION_ATTACHMENTS_DELETED: 'Bulk Operation - Attachments Deleted',
        BULK_OPERATION_ATTACHMENTS_DOWNLOADED: 'Bulk Operation - Attachments Downloaded',
        BULK_OPERATION_ATTACHMENTS_TO_CATEGORY_MOVED: 'Bulk Operation - Attachments to Category Moved',
        BULK_OPERATION_ATTACHMENTS_TO_EMAIL_SENT: 'Bulk Operation - Attachments to Email Sent',
        BULK_OPERATION_ATTACHMENTS_ARCHIVED: 'Bulk Operation - Attachments Archived',
        COUNT_ATTACHMENTS_IN_ISSUE: 'Count Attachments in Issue',
        COMMENT_THREAD_ADDED: 'Comment Thread Added',
        COMMENT_THREAD_DELETED: 'Comment Thread Deleted',
        NEW_COMMENT_ADDED: 'New Comment Added',
        COMMENT_DELETED: 'Comment Deleted',
        COMMENT_EDITED: 'Comment Edited',
        CREATE_ISSUE_FORM_DRAG_N_DROP_ATTACHMENT: 'Create Issue Form - Drag-n-Drop Attachment',
        CREATE_ISSUE_FORM_ATTACHMENT_BROWSE_UPLOAD: 'Create Issue Form - Attachment Browse Upload',
        ATTACH_FILES_FORM_DRAG_N_DROP_ATTACHMENT: 'Attach Files Form - Drag-n-Drop Attachment',
        ATTACH_FILES_FORM_ATTACHMENT_BROWSE_UPLOAD: 'Attach Files Form - Attachment Browse Upload',
        ATTACH_SCREENSHOT_FORM_ATTACHMENT: 'Attach Screenshot Form Attachment',
        TRANSITION_FORM_DRAG_N_DROP_ATTACHMENT: 'Transition Form - Drag-n-Drop Attachment',
        TRANSITION_FORM_ATTACHMENT_BROWSE_UPLOAD: 'Transition Form - Attachment Browse Upload',
        ATTACHMENT_UPLOAD: 'Attachment Upload',
        MANUAL_DOCUMENT_REVISION_UPLOAD: 'Manual Document Revision Upload',
        AUTOMATIC_DOCUMENT_REVISION_UPLOAD: 'Automatic Document Revision Upload',
    };

    var dimensions = {
        ACCESS_RESTRICTIONS_RATIO: 'dimension1',
        AUTO_DISTRIBUTION_RULE_RATIO: 'dimension2',
        ATTACHMENTS_COUNT: 'dimension3',
        CATEGORY_COUNT: 'dimension4',
        CATEGORY_ID: 'dimension5',
        DEPLOYMENT: 'dimension6',
        FILE_EXTENSION: 'dimension7',
        ISSUE_TYPES_RATIO: 'dimension8',
        JIRA_LICENSE_TYPE: 'dimension9',
        PLUGIN_LICENSE_SIZE: 'dimension10',
        PROJECT_ID: 'dimension11',
        PROJECT_TYPE: 'dimension12',
        SCHEME_ID: 'dimension13',
        SCHEME_TYPE: 'dimension14',
        SERVER_ID_HASH: 'dimension15',
        USER_ID: 'dimension16',
        APP_VERSION: 'dimension17'
    };

    return {
        tid: tid,
        screens: screens,
        actions: actions,
        categories: categories,
        dimensions: dimensions
    }
});