(function ($) {

    window.SmartAttachAnalytics = {

        TID: "UA-18056811-19",
        serverHash: "",

        Screens: {
            CONF_PAGE: 'Opening Project Add-on Setup',
            ISSUE: 'Opening Issue',
            ADDON_ADMIN_PAGE: 'Add-on Administration',
            POP_UP_FORM: 'Pop-up Form',
            WORKFLOW: 'Workflow Administration'
        },

        EvActions: {
            ON: 'Project Add-on Enabled',
            OFF: 'Project Add-on Disabled',
            EDIT: 'Category Editing',
            NEW_CAT: 'Category Created',
            DELETE_CAT: 'Category Deleted',
            RENAME_CAT: 'Category Renaming',
            EDIT_IN_OFFICE: 'Office File Editing',
            RENAME_ATT: 'Attachment Renaming',
            IMPORT: 'Category Importing',
            DND_ATT: 'Attachment Drag-n-Drop',
            FORM_TRANSITION_ATT: 'Transition Form Attachment',
            FORM_SCREENSHOT_ATT: 'Attach Screenshot Attachment',
            FORM_ATTACH_FILES_ATT: 'Attach Files Attachment',
            CREATE_ISSUE_ATT: 'Create Issue Attachment',
            UPLOAD_NEW_REV: 'Document Revision Upload',
            SEND_TO_EMAIL: 'Attachment to Email Sending',
            MOVE: 'Attachment Moving Between Categories',
            BULK: 'Bulk Operation',
            DOWNLOAD: 'Attachment Download',
            ARCHIVE: 'Attachment Archiving',
            DELETE: 'Attachment Removal',
            UPLOAD: 'Attachment Upload',
            SAVE_AFTER_EDIT: 'Category Saving After Edit',
            ANALYTICS_ON: 'Analytics Enabled',
            ANALYTICS_OFF: 'Analytics Disabled',
            COMMENT_ADD: 'New Comment Adding',
            COMMENT_DELETE: 'Comment Deleting',
            COMMENT_EDIT: 'Comment Editing',
            COMMENT_THREAD_ADD: 'Comment Thread Adding',
            COMMENT_THREAD_DELETE: 'Comment Thread Deleting',
            EDIT_WITH_GOEDIT: 'Editing with GoEdit',
            FILE_UPL_USER_ADD: 'File Uploader User - Adding',
            FILE_UPL_GROUP_ADD: 'File Uploader Group - Adding',
            FILE_UPL_PROJECT_ROLE_ADD: 'File Uploader Project Role - Adding',
            CATEGORY_NOT_EMPTY_ADD: 'Category Not Empty - Adding',
            ATTACH_FROM_CATEGORY_REMOVE: 'Attachment from Category Removal',
            ATTACH_TO_CATEGORY_MOVE: 'Attachment to Category Moving',
            LIMIT_ATT_IN_CATEGORY: 'Limit Attachments in Category - Adding',
            ON_BOARDING_EXPLORE: 'Explore App Button Click',
            ON_BOARDING_DO_NOT_SHOW_ANYMORE: 'Not Show Anymore Link Click'
        },

        EvCategories: {
            PROJECT: 'project',
            CAT: 'category',
            CONF: 'configuration',
            ATTACH_METHOD: 'attachment_method',
            ATTACHMENT: 'attachment',
            EVENT_ANALYTICS: 'Event Analytics',
            ATTACH_COMMENT: 'Attachment Commenting',
            WORKFLOW_CONDITION: 'Workflow Condition',
            WORKFLOW_VALIDATOR: 'Workflow Validator',
            WORKFLOW_POST_FUNCTION: 'Workflow Post Function',
            ON_BOARDING: 'onboarding'
        },

        Dimensions: {
            SERVER_HASH: 'cd1',
            PRJ_RATIO: 'cd2',
            BULK_SIZE: 'cd3',
            FILE_EXT: 'cd4',
            PRJ_TYPES_RATIO: 'cd5',
            PROJECT_HASH: 'cd6',
            ISSUE_TYPES_RATIO: 'cd7',
            ACCESS_RESTR_RATIO: 'cd8',
            USER_ID: 'cd9',
            ADDON_CONDITION: 'cd10',
            PLUGIN_LIC_SIZE: 'cd11'
        },

        isActiveGA: function () {
            var t = this;
            if (t.activeGA === undefined) {
                t.activeGA = this.getRestData('activeGA') === "true";
            }
            return t.activeGA;
        },

        isAnonymous: function () {
            return $.ajax({
                type: "GET",
                async: false,
                url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics/isAnonymous',
                success: function (data) {
                    return data;
                }
            }).responseText === "true";
        },

        getRestData: function (name) {
            var t = this;

            t.anonymous = t.anonymous === undefined ? t.isAnonymous() : t.anonymous;

            if (!t.anonymous) {
                return $.ajax({
                    type: "GET",
                    async: false,
                    url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics/' + name,
                    success: function (data) {
                        return data;
                    },
                    error: function () {
                    }
                }).responseText;
            }

            return "";
        },

        send: function (data) {
            if (this.isActiveGA()) {
                $.ajax({
                    type: "POST",
                    url: "https://www.google-analytics.com/collect",
                    data: data,
                    error: function (data) {
                        console.error(data);
                    }
                });
            }
        },

        view: function(screenName, dimensions) {
            var t = this;
            var sid = t.getServerHash();
            var uid = t.getUserId();

            var data = {
                aip: 1,
                av: t.getPluginVersion(),
                v: 1,
                an: "Smart Attachments",
                t: "appview",
                tid: t.TID,
                dp: "/ProjectAttachmentCategoryAction.jspa",
                cd: screenName,
                cid: sid,
                uid: uid,
                z: t.getRandomInt()
            };
            data[t.Dimensions.SERVER_HASH] = sid;
            data = t.mergeDimensions(data, dimensions);

            t.send(data);
        },

        event: function (screenName, eventCategory, eventAction, dimensions) {
            var t = this;
            var sid = t.getServerHash();
            var uid = t.getUserId();

            var data = {
                aip: 1,
                v: 1,
                an: "Smart Attachments",
                av: t.getPluginVersion(),
                t: "event",
                tid: t.TID,
                cid: sid,
                uid: uid,
                el: sid,
                cd: screenName,
                ec: eventCategory,
                ea: eventAction,
                z: t.getRandomInt()
            };
            data[t.Dimensions.SERVER_HASH] = sid;
            data[t.Dimensions.USER_ID] = uid;
            data = t.mergeDimensions(data, dimensions);

            t.send(data);
        },

        viewConfigPage: function() {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.ADDON_CONDITION] = t.isActiveAddon();
            this.view(this.Screens.CONF_PAGE, dimensions);
        },

        eventEnableAddOn: function (data) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PRJ_RATIO] = data.prjRatio;
            dimensions[t.Dimensions.PRJ_TYPES_RATIO] = data.prjTypesRatio;
            dimensions[t.Dimensions.PROJECT_HASH] = t.getProjectHash();
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.PROJECT, t.EvActions.ON, dimensions);
        },

        eventDisableAddOn: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PROJECT_HASH] = t.getProjectHash();
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.PROJECT, t.EvActions.OFF, dimensions);
        },

        eventCreateCategory: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PROJECT_HASH] = t.getProjectHash();
            dimensions[t.Dimensions.ISSUE_TYPES_RATIO] = t.getIssueTypesRatio();
            dimensions[t.Dimensions.ACCESS_RESTR_RATIO] = t.getAccessRestrictionsRatio();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.CAT, t.EvActions.NEW_CAT, dimensions);
        },

        eventDeleteCategory: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PROJECT_HASH] = t.getProjectHash();
            dimensions[t.Dimensions.ISSUE_TYPES_RATIO] = t.getIssueTypesRatio();
            dimensions[t.Dimensions.ACCESS_RESTR_RATIO] = t.getAccessRestrictionsRatio();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.CAT, t.EvActions.DELETE_CAT, dimensions);
        },

        eventEditCategory: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PROJECT_HASH] = t.getProjectHash();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.CAT, t.EvActions.EDIT, dimensions);
        },

        eventSaveEditedCategory: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PROJECT_HASH] = t.getProjectHash();
            dimensions[t.Dimensions.ISSUE_TYPES_RATIO] = t.getIssueTypesRatio();
            dimensions[t.Dimensions.ACCESS_RESTR_RATIO] = t.getAccessRestrictionsRatio();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.CAT, t.EvActions.SAVE_AFTER_EDIT, dimensions);
        },

        eventRenameCategory: function () {
            var t = this;
            t.event(t.Screens.CONF_PAGE, t.EvCategories.CAT, t.EvActions.RENAME_CAT);
        },

        eventProjectImport: function () {
            var t = this;
            t.event(t.Screens.CONF_PAGE, t.EvCategories.CONF, t.EvActions.IMPORT);
        },

        eventOnBoardingExplore: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.ON_BOARDING, t.EvActions.ON_BOARDING_EXPLORE, dimensions);
        },

        eventOnBoardingDoNotShowAnymore: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            t.event(t.Screens.CONF_PAGE, t.EvCategories.ON_BOARDING, t.EvActions.ON_BOARDING_DO_NOT_SHOW_ANYMORE, dimensions);
        },

        eventAttachDND: function () {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_METHOD, t.EvActions.DND_ATT);
        },

        eventAttachForm: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();

            if ($('#attachscreenshotname').length) {
                SmartAttachAnalytics.eventAttachFormScreenshot(dimensions);
            } else if ($('#issue-workflow-transition').length) {
                SmartAttachAnalytics.eventAttachFormTransition(dimensions);
            } else {
                SmartAttachAnalytics.eventAttachFormAttachFiles(dimensions);
            }
        },

        eventAttachFormScreenshot: function (dimensions) {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_METHOD, t.EvActions.FORM_SCREENSHOT_ATT, dimensions);
        },

        eventAttachFormTransition: function (dimensions) {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_METHOD, t.EvActions.FORM_TRANSITION_ATT, dimensions);
        },

        eventAttachFormAttachFiles: function (dimensions) {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_METHOD, t.EvActions.FORM_ATTACH_FILES_ATT, dimensions);
        },

        eventAttachCreateIssue: function () {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_METHOD, t.EvActions.CREATE_ISSUE_ATT, dimensions);
        },

        eventUploadNewRevision: function () {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.UPLOAD_NEW_REV);
        },

        eventAttachmentRename: function () {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.RENAME_ATT);
        },

        eventAttachmentSendToEmail: function () {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.SEND_TO_EMAIL);
        },

        eventAttachmentMoveBetweenCat: function () {
            var t = this;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.MOVE);
        },

        eventAttachmentEditInOffice: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.EDIT_IN_OFFICE, dimensions);
        },

        eventBulkOpDelete: function (countFiles) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.BULK_SIZE] = countFiles;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.BULK + " " + t.EvActions.DELETE, dimensions);
        },

        eventBulkOpDownload: function (countFiles) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.BULK_SIZE] = countFiles;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.BULK + " " + t.EvActions.DOWNLOAD, dimensions);
        },

        eventBulkOpMove: function (countFiles) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.BULK_SIZE] = countFiles;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.BULK + " " + t.EvActions.MOVE, dimensions);
        },

        eventBulkOpSendEmail: function (countFiles) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.BULK_SIZE] = countFiles;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.BULK + " " + t.EvActions.SEND_TO_EMAIL, dimensions);
        },

        eventBulkOpArchive: function (countFiles) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.BULK_SIZE] = countFiles;
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.BULK + " " + t.EvActions.ARCHIVE, dimensions);
        },

        eventUploadFile: function (fileName) {
            var t = this;
            var dimensions = {};
            if (fileName) {
                dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileName);
                t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.UPLOAD, dimensions);
            }
        },

        eventDisableAnalytics: function (screen) {
            var t = this;
            t.event(screen, t.EvCategories.EVENT_ANALYTICS, t.EvActions.ANALYTICS_OFF);
        },

        eventEnableAnalytics: function (screen) {
            var t = this;
            t.event(screen, t.EvCategories.EVENT_ANALYTICS, t.EvActions.ANALYTICS_ON);
        },

        eventCreateCommentThread: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_COMMENT, t.EvActions.COMMENT_THREAD_ADD, dimensions);
        },

        eventDeleteCommentThread: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_COMMENT, t.EvActions.COMMENT_THREAD_DELETE, dimensions);
        },

        eventCreateComment: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_COMMENT, t.EvActions.COMMENT_ADD, dimensions);
        },

        eventDeleteComment: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_COMMENT, t.EvActions.COMMENT_DELETE, dimensions);
        },

        eventEditComment: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACH_COMMENT, t.EvActions.COMMENT_EDIT, dimensions);
        },

        eventEditWithGoEdit: function (fileUrl) {
            var t = this;
            var dimensions = {};
            dimensions[t.Dimensions.FILE_EXT] = t.parseFileExtension(fileUrl);
            t.event(t.Screens.ISSUE, t.EvCategories.ATTACHMENT, t.EvActions.EDIT_WITH_GOEDIT, dimensions);
        },

        eventWorkflowConditionCategoryNotEmptyAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_CONDITION, t.EvActions.CATEGORY_NOT_EMPTY_ADD, dimensions);
        },

        eventWorkflowValidatorCategoryNotEmptyAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_VALIDATOR, t.EvActions.CATEGORY_NOT_EMPTY_ADD, dimensions);
        },

        eventWorkflowConditionFileUploaderUserAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_CONDITION, t.EvActions.FILE_UPL_USER_ADD, dimensions);
        },

        eventWorkflowValidatorFileUploaderUserAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_VALIDATOR, t.EvActions.FILE_UPL_USER_ADD, dimensions);
        },

        eventWorkflowConditionFileUploaderGroupAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_CONDITION, t.EvActions.FILE_UPL_GROUP_ADD, dimensions);
        },

        eventWorkflowValidatorFileUploaderGroupAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_VALIDATOR, t.EvActions.FILE_UPL_GROUP_ADD, dimensions);
        },

        eventWorkflowConditionFileUploaderProjectRoleAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_CONDITION, t.EvActions.FILE_UPL_PROJECT_ROLE_ADD, dimensions);
        },

        eventWorkflowValidatorFileUploaderProjectRoleAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_VALIDATOR, t.EvActions.FILE_UPL_PROJECT_ROLE_ADD, dimensions);
        },

        eventWorkflowPostFunctionAttachmentFromCategoryRemoval: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_POST_FUNCTION, t.EvActions.ATTACH_FROM_CATEGORY_REMOVE, dimensions);
        },

        eventWorkflowPostFunctionAttachmentToCategoryMoving: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_POST_FUNCTION, t.EvActions.ATTACH_TO_CATEGORY_MOVE, dimensions);
        },

        eventWorkflowPostFunctionAttachmentToEmailSending: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_POST_FUNCTION, t.EvActions.SEND_TO_EMAIL, dimensions);
        },

        eventWorkflowConditionLimitAttachmentsInCategoryAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_CONDITION, t.EvActions.LIMIT_ATT_IN_CATEGORY, dimensions);
        },

        eventWorkflowValidatorLimitAttachmentsInCategoryAdded: function (dimensions) {
            var t = this;
            t.event(t.Screens.WORKFLOW, t.EvCategories.WORKFLOW_VALIDATOR, t.EvActions.LIMIT_ATT_IN_CATEGORY, dimensions);
        },

        mergeDimensions: function (o1, o2){
            return $.extend({}, o1, o2);
        },

        getIssueTypesRatio: function () {
            return this.getRatioOfMultiSelectedItems('.issue-types-container');
        },

        getAccessRestrictionsRatio: function () {
            return this.getRatioOfMultiSelectedItems('.restrictions-container');
        },

        getRatioOfMultiSelectedItems: function (container) {
            var accessRestContainer = $(container + " .select2-choices");
            var countAll = accessRestContainer.length - 1;
            var countActive = 0;
            $.each(accessRestContainer, function (i) {
                var length = $(this).find('.select2-search-choice').length;
                if (i > 0 && length > 0) {
                    countActive++;
                }
            });
            return countActive + "/" + countAll;
        },

        getPluginVersion: function () {
            var t = this;
            if (!t.pluginVersion) {
                t.pluginVersion = t.getRestData('pluginVersion');
            }
            return t.pluginVersion;
        },

        getPluginLicenseSize: function () {
            var t = this;
            if (!t.pluginLicenseSize) {
                t.pluginLicenseSize = t.getRestData('licenseSize');
            }
            return t.pluginLicenseSize;
        },

        getServerHash: function () {
            var t = this;
            if (!t.serverHash) {
                var meta = $('meta[name=serverHash]').attr("content");
                t.serverHash = meta ? meta : t.getRestData('serverHash');
            }
            return t.serverHash;
        },

        getUserId: function () {
            var t = this;
            var id = t.getCookie("smart-attach-userId");
            if (id == '') {
                id = t.getRandomInt();
                t.setCookie("smart-attach-userId", id);
            }
            return id;
        },

        getProjectHash: function () {
            return $('meta[name=projectHash]').attr("content");
        },

        isActiveAddon: function () {
            return $('#enable-smart-attach-checkbox').is(":checked");
        },

        setCookie: function (name, value) {
            document.cookie = name + "=" + encodeURIComponent(value) + "; max-age=" + 60 * 60 * 24 * 3000;
        },

        getCookie: function (name) {
            var cookie = document.cookie;
            if (cookie.length !== 0) {
                var re = new RegExp('[; ]' + name + '=([^\\s;]*)');
                var matcher = (' ' + document.cookie).match(re);
                if (matcher) {
                    return decodeURIComponent(matcher[1]);
                }
            }
            return '';
        },

        getRandomInt: function () {
            var max = 99999999999999999;
            return Math.floor(Math.random() * (max - 1));
        },

        parseFileExtension: function (fileName) {
            if (fileName.length) {
                fileName = fileName.toLowerCase();
            }
            var indexDot = fileName.lastIndexOf(".");
            var length = fileName.length;
            var diff = length - indexDot - 1;
            return (diff !== length) && (diff <= 5) ? fileName.substring(indexDot + 1) : "no file format";
        }
    };
})(AJS.$);