(function ($) {

    var messageContainerSelector = '#sa-message-container';

    var setAnalyticsState = function (isActive) {
        $.ajax({
            type: 'POST',
            url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics',
            data: {
                active: isActive
            },
            success: function () {
                $(messageContainerSelector).remove();
            }
        });
    };

    var showGAMessage = function () {
        $('body').prepend(SmartAttachments.GA.Templates.container());

        makeMessage();

        var messageContainer = $(messageContainerSelector);
        bindGAMessageEnableClick(messageContainer);
        bindGAMessageDisableClick(messageContainer);
    };

    var bindGAMessageEnableClick = function (messageContainer) {
        messageContainer.find('#sa-ga-enable').click(function () {
            SmartAttachmentsAnalytics.event('enableAnalytics', ['Pop-up Form']);
            setAnalyticsState(true);
        });
    };

    var bindGAMessageDisableClick = function (messageContainer) {
        messageContainer.find('#sa-ga-disable').click(function () {
            SmartAttachmentsAnalytics.event('disableAnalytics', ['Pop-up Form']);
            setAnalyticsState(false);
        });
    };

    var makeMessage = function () {
        var disableInfoUrl = AJS.params.baseURL + "/secure/SmartAttachmentsMaintenance.jspa";

        AJS.messages.warning(messageContainerSelector, {
            title: AJS.I18n.getText('attach.cat.tracking-notification.title'),
            body: SmartAttachments.GA.Templates.messageBody({disableInfoUrl: disableInfoUrl}),
            closeable: false
        });
    };

    AJS.toInit(showGAMessage);

})(AJS.$);