(function ($) {

    AJS.toInit(function () {

        var isAnonymous = function () {
            return $.ajax({
                    type: "GET",
                    async: false,
                    url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics/isAnonymous',
                    success: function (data) {
                        return data;
                    }
                }).responseText === "true";
        };

        var updateAnalytics = function (enabled) {
            $.ajax({
                type: 'POST',
                url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics/setActiveGA',
                data: {
                    active: enabled
                },
                success: function () {
                    $('#attach-cat-container').remove();
                }
            });
        };

        if (!isAnonymous()) {
            $.ajax({
                type: 'GET',
                url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics/notification',
                success: function (data) {
                    if (data == "true") {
                        $('body').prepend("<div id='attach-cat-container'></div>");

                        var body = "<p>" + AJS.I18n.getText('attach.cat.tracking-notification.body') + "</p>" +
                            "<p>" + AJS.I18n.getText('attach.cat.tracking-notification.disable-info', AJS.params.baseURL +
                            "/secure/SmartAttachmentsConfig.jspa") + "</p><br/><button id='enable' class='aui-button'>" +
                            AJS.I18n.getText('attach.cat.tracking-notification.allow') +
                            "</button><button id='disable' class='aui-button aui-button-link'>" +
                            AJS.I18n.getText('attach.cat.tracking-notification.disable') + "</button>";

                        AJS.messages.warning('#attach-cat-container', {
                            title: AJS.I18n.getText('attach.cat.tracking-notification.title'),
                            body: body,
                            closeable: false
                        });

                        var messageContainer = $('#attach-cat-container');

                        messageContainer.find('#enable').click(function () {
                            SmartAttachAnalytics.eventEnableAnalytics(SmartAttachAnalytics.Screens.POP_UP_FORM);
                            updateAnalytics(true);
                        });

                        messageContainer.find('#disable').click(function () {
                            SmartAttachAnalytics.eventDisableAnalytics(SmartAttachAnalytics.Screens.POP_UP_FORM);
                            updateAnalytics(false);
                        });
                    }
                },
                error: function (data) {
                    console.error(data);
                }
            });
        }
    });
})(AJS.$);