(function ($) {

    var workflowItemNames = {
        CATEGORY_NOT_EMPTY_CONDITION: 'category-is-not-empty-condition',
        FILE_UPL_USER_CONDITION: 'file-uploader-is-user-condition',
        FILE_UPL_GROUP_CONDITION: 'file-uploader-in-group-condition',
        FILE_UPL_PR_ROLE_CONDITION: 'file-uploader-in-project-role-condition',
        LIMIT_ATT_IN_CATEGORY_CONDITION: 'limit-attachments-condition',

        CATEGORY_NOT_EMPTY_VALIDATOR: 'category-is-not-empty-validator',
        FILE_UPL_USER_VALIDATOR: 'file-uploader-is-user-validator',
        FILE_UPL_GROUP_VALIDATOR: 'file-uploader-in-group-validator',
        FILE_UPL_PR_ROLE_VALIDATOR: 'file-uploader-in-project-role-validator',
        LIMIT_ATT_IN_CATEGORY_VALIDATOR: 'limit-attachments-validator',

        ATTACH_FROM_CATEGORY_REMOVE: 'delete-from-categories-function',
        ATTACH_TO_CATEGORY_MOVE: 'move-between-categories-function',
        ATTACH_TO_EMAIL_SEND: 'send-to-email-function'
    };

    function bindSubmit() {
        if (getProjectHash() === '') {
            return;
        }

        $('form[method="post"]').submit(function () {
            SmartAttachmentsAnalytics.event(getAnalyticsEventName());
        })
    }

    function getAnalyticsEventName() {
        switch (getWorkflowItemType()) {
            case workflowItemNames.CATEGORY_NOT_EMPTY_CONDITION: {
                return 'workflowConditionCategoryNotEmptyAdded';
            }
            case workflowItemNames.FILE_UPL_USER_CONDITION: {
                return 'workflowConditionFileUploaderUserAdded';
            }
            case workflowItemNames.FILE_UPL_GROUP_CONDITION: {
                return 'workflowConditionFileUploaderGroupAdded';
            }
            case workflowItemNames.FILE_UPL_PR_ROLE_CONDITION: {
                return 'workflowConditionFileUploaderProjectRoleAdded';
            }
            case workflowItemNames.CATEGORY_NOT_EMPTY_VALIDATOR: {
                return 'workflowValidatorCategoryNotEmptyAdded';
            }
            case workflowItemNames.FILE_UPL_USER_VALIDATOR: {
                return 'workflowValidatorFileUploaderUserAdded';
            }
            case workflowItemNames.FILE_UPL_GROUP_VALIDATOR: {
                return 'workflowValidatorFileUploaderGroupAdded';
            }
            case workflowItemNames.FILE_UPL_PR_ROLE_VALIDATOR: {
                return 'workflowValidatorFileUploaderProjectRoleAdded';
            }
            case workflowItemNames.ATTACH_TO_CATEGORY_MOVE: {
                return 'workflowPostFunctionAttachmentToCategoryMoving';
            }
            case workflowItemNames.ATTACH_FROM_CATEGORY_REMOVE: {
                return 'workflowPostFunctionAttachmentFromCategoryRemoval';
            }
            case workflowItemNames.ATTACH_TO_EMAIL_SEND: {
                return 'workflowPostFunctionAttachmentToEmailSending';
            }
            case workflowItemNames.LIMIT_ATT_IN_CATEGORY_CONDITION: {
                return 'workflowConditionLimitAttachmentsInCategoryAdded';
            }
            case workflowItemNames.LIMIT_ATT_IN_CATEGORY_VALIDATOR: {
                return 'workflowValidatorLimitAttachmentsInCategoryAdded';
            }
            default: {
                break;
            }
        }
    }

    function getWorkflowItemType() {
        var pluginModuleKey = $('#pluginModuleKey').val();
        return pluginModuleKey.replace('com.stiltsoft.jira.smart-attachments:', '');
    }

    function getProjectHash () {
        return $('meta[name=projectHash]').attr("content");
    }

    AJS.toInit(function () {
        bindSubmit();
    });
})(AJS.$);