(function ($) {

    window.SAWorflowItemNames = {
        CATEGORY_NOT_EMPTY_CONDITION: 'category-is-not-empty-condition',
        FILE_UPL_USER_CONDITION: 'file-uploader-is-user-condition',
        FILE_UPL_GROUP_CONDITION: 'file-uploader-in-group-condition',
        FILE_UPL_PR_ROLE_CONDITION: 'file-uploader-in-project-role-condition',
        LIMIT_ATT_IN_CATEGORY_CONDITION: 'limit-attachments-condition',

        CATEGORY_NOT_EMPTY_VALIDATOR: 'category-is-not-empty-validator',
        FILE_UPL_USER_VALIDATOR: 'file-uploader-is-user-validator',
        FILE_UPL_GROUP_VALIDATOR: 'file-uploader-in-group-validator',
        FILE_UPL_PR_ROLE_VALIDATOR: 'file-uploader-in-project-role-validator',
        LIMIT_ATT_IN_CATEGORY_VALIDATOR: 'limit-attachments-validator',

        ATTACH_FROM_CATEGORY_REMOVE: 'delete-from-categories-function',
        ATTACH_TO_CATEGORY_MOVE: 'move-between-categories-function',
        ATTACH_TO_EMAIL_SEND: 'send-to-email-function'
    };

    function bindSubmit() {

        if (getProjectHash() === '') {
            return;
        }

        $('form[method="post"]').submit(function () {
            var saa = SmartAttachAnalytics;
            var dimensions = getGADimensions();

            switch (getWorkflowItemType()) {
                case SAWorflowItemNames.CATEGORY_NOT_EMPTY_CONDITION: {
                    saa.eventWorkflowConditionCategoryNotEmptyAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.FILE_UPL_USER_CONDITION: {
                    saa.eventWorkflowConditionFileUploaderUserAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.FILE_UPL_GROUP_CONDITION: {
                    saa.eventWorkflowConditionFileUploaderGroupAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.FILE_UPL_PR_ROLE_CONDITION: {
                    saa.eventWorkflowConditionFileUploaderProjectRoleAdded(dimensions);
                    break;
                }

                case SAWorflowItemNames.CATEGORY_NOT_EMPTY_VALIDATOR: {
                    saa.eventWorkflowValidatorCategoryNotEmptyAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.FILE_UPL_USER_VALIDATOR: {
                    saa.eventWorkflowValidatorFileUploaderUserAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.FILE_UPL_GROUP_VALIDATOR: {
                    saa.eventWorkflowValidatorFileUploaderGroupAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.FILE_UPL_PR_ROLE_VALIDATOR: {
                    saa.eventWorkflowValidatorFileUploaderProjectRoleAdded(dimensions);
                    break;
                }

                case SAWorflowItemNames.ATTACH_TO_CATEGORY_MOVE: {
                    saa.eventWorkflowPostFunctionAttachmentToCategoryMoving(dimensions);
                    break;
                }
                case SAWorflowItemNames.ATTACH_FROM_CATEGORY_REMOVE: {
                    saa.eventWorkflowPostFunctionAttachmentFromCategoryRemoval(dimensions);
                    break;
                }
                case SAWorflowItemNames.ATTACH_TO_EMAIL_SEND: {
                    saa.eventWorkflowPostFunctionAttachmentToEmailSending(dimensions);
                    break;
                }
                case SAWorflowItemNames.LIMIT_ATT_IN_CATEGORY_CONDITION: {
                    saa.eventWorkflowConditionLimitAttachmentsInCategoryAdded(dimensions);
                    break;
                }
                case SAWorflowItemNames.LIMIT_ATT_IN_CATEGORY_VALIDATOR: {
                    saa.eventWorkflowValidatorLimitAttachmentsInCategoryAdded(dimensions);
                    break;
                }

                default: {
                    break;
                }
            }
        })
    }

    function getWorkflowItemType() {
        var pluginModuleKey = $('#pluginModuleKey').val();
        return pluginModuleKey.replace('com.stiltsoft.jira.smart-attachments:', '');
    }

    function getGADimensions() {
        var t = SmartAttachAnalytics;
        var dimensions = {};
        dimensions[t.Dimensions.PROJECT_HASH] = getProjectHash();
        dimensions[t.Dimensions.PLUGIN_LIC_SIZE] = t.getPluginLicenseSize();
        return dimensions;
    }

    function getProjectHash() {
        return $('#workflow-item-info').data('projectHash');
    }

    AJS.toInit(function () {
        bindSubmit();
    });
})(AJS.$);