require([
    'jquery',
    'underscore',
    'smart-attachments/dialog/AttachFilesDecorator'
], function ($, _, AttachFilesDecorator) {
    var EXPECTED_IDS = ['prefillable-edit-issue-dialog', 'edit-issue-dialog'];

    function isEditIssueDialog(dialog) {
        return EXPECTED_IDS.indexOf(dialog.options.id) > -1;
    }

    function createDecorator(dialog, issue) {
        var uploadInfo = {
            issue: issue
        };
        decorator = new AttachFilesDecorator({
            dialog: dialog,
            uploadInfo: uploadInfo
        });
    }

    function createIssue() {
        var link = document.querySelector('a.issue-link');
        if (link) {
            var issueKey = link.dataset['issueKey'];
            var issueId = link.getAttribute('rel');
            return {
                getIssueId: function () {
                    return issueId;
                },
                getIssueKey: function () {
                    return issueKey;
                }
            }
        }
    }

    function onDialogReady(event, dialog) {
        if (!isEditIssueDialog(dialog)) {
            return;
        }
        console.log("Create decorator");
        var issue = createIssue();
        if (issue) {
            createDecorator(dialog, issue);
        }
    }

    function init() {
        if (document.querySelector('#issue-edit')) {
            console.log('direct mode');
            var dialogStub = {
                $popupContent: $(document.querySelector('section.aui-page-panel-content')),
                options: {
                    id: 'edit-issue-dialog'
                }
            };
            onDialogReady(null, dialogStub);
        } else {
            console.log("dialog mode");
        }
    }

    if ($.isReady) {
        init();
    } else {
        AJS.toInit(init);
    }
});