(function ($) {

    AJS.toInit(function () {
        var indexProgress = $('#smart-attach-indexing');
        var indexFinished = $('#smart-attach-finished');
        var indexed = indexProgress.find('#smart-attach-indexed');
        var indexTotal = indexProgress.find('#smart-attach-index-total');
        var indexPB = indexProgress.find('#smart-attach-done');
        var indexBtn = $('#index-smart-attach');
        var analyticsCheckbox = $('#analytics-checkbox');
        var indexSpinner = $('#smart-attach-indexation-spinner');

        var checkIndexProgress = function() {
            JIRA.SmartAjax.makeRequest({
                type: 'GET',
                url: AJS.params.baseURL + '/rest/attach-cat/1.0/maintenance/index',
                success: function(data) {
                    indexed.html(data.indexed);
                    indexTotal.html(data.total);
                    indexPB.width(indexProgress.width() * data.indexed / data.total);
                    if (!data.indexing && data.indexed === null) {
                        indexProgress.hide();
                        indexFinished.show();
                    } else {
                        if (data.total !== null) {
                            hideSpinner(indexSpinner);
                            indexProgress.show();
                        } else {
                            showSpinner(indexSpinner);
                        }
                        setTimeout(checkIndexProgress, 5000);
                    }
                },
                error: function() {
                    JIRA.Messages.showMsg(AJS.I18n.getText("attach.cat.action.maintenance.error"), {
                        type: JIRA.Messages.Types.ERROR,
                        closeable: false,
                        timeout: 3
                    });
                }
            });
        };

        indexBtn.click(function() {
            JIRA.SmartAjax.makeRequest({
                type: 'POST',
                url: AJS.params.baseURL + '/rest/attach-cat/1.0/maintenance/index',
                success: function() {
                    indexBtn.hide();
                    checkIndexProgress();
                },
                error: function() {
                    JIRA.Messages.showMsg(AJS.I18n.getText("attach.cat.action.maintenance.error"), {
                        type: JIRA.Messages.Types.ERROR,
                        closeable: false,
                        timeout: 3
                    });
                }
            });
            return false;
        });

        if (indexProgress.is(':visible')) {
            checkIndexProgress();
        }

        analyticsCheckbox.click(function(e) {
            e.preventDefault();
            e.stopPropagation();

            var checked = $(this).is(":checked");

            if (!checked) {
                SmartAttachmentsAnalytics.event('disableAnalytics', ['Add-on Administration']);
            }
            $.ajax({
                type: 'POST',
                url: AJS.params.baseURL + '/rest/attach-cat/1.0/analytics',
                data: {
                    active: checked
                },
                success: function() {
                    if (checked) {
                        SmartAttachmentsAnalytics.event('enableAnalytics', ['Add-on Administration']);
                    }
                    analyticsCheckbox.prop('checked', checked);
                },
                error: function() {}
            });
        });

        initInfoInlineDialog("#info-ga-icon", "info-ga-dialog", "#info-ga-container");
        initInfoInlineDialog("#info-index-icon", "info-index-dialog", "#info-index-container");
    });
    
    function showSpinner(indexSpinner) {
        indexSpinner.css('display', 'inline-block');
    }
    
    function hideSpinner(indexSpinner) {
        indexSpinner.hide();
    }

    function initInfoInlineDialog (icon, desiredIdDialog, container) {
        return AJS.InlineDialog(AJS.$(icon), desiredIdDialog,
            function (content, trigger, showPopup) {
                content.css({"padding": "20px"}).html($(container).html());
                showPopup();
                return false;
            },
            {
                offsetX: -10,
                width:350
            }
        );
    }
})(AJS.$);
