(function ($) {

    var inlineDialogShow = false;

    AJS.toInit(function () {
        showInlineForSAConfigLink();
    });

    function showInlineForSAConfigLink() {
        var $menuLink = getMenuLink();
        if (!$menuLink.length) {
            return;
        }

        if ($menuLink.parent().hasClass('aui-nav-selected')) {
            return;
        }

        JIRA.SmartAjax.makeRequest({
            type: 'GET',
            url: AJS.params.baseURL + '/rest/attach-cat/1.0/settings/onboarding',
            data: {
                projectKey: getProjectKey()
            },
            success: function (data) {
                if (data === 'true') {
                    createHotspotAndDialog($menuLink);
                }
            }
        });
    }

    function createHotspotAndDialog() {
        var $hotspot = createHotspot();
        var hotspotDialog = createDialogOnHotspot($hotspot);

        $hotspot.click(function () {
            if (inlineDialogShow) {
                hotspotDialog.hide();
                inlineDialogShow = false;
            } else {
                hotspotDialog.show();
                inlineDialogShow = true;
            }
        });

        $('body').on('click', '#skip-sa-onboarding', function () {
            markOnBoardingAsShowed();
            hotspotDialog.hide();
        }).on('mousedown', '#show-sa-onboarding', function () {
        });
    }

    function createDialogOnHotspot($hotspot) {
        return AJS.InlineDialog($hotspot, "sa-on-boarding-dialog",
            function (content, trigger, showPopup) {
                var onBoardingLink = getMenuLink().attr('href');
                var containerBody = SAOnBoardingTemplates.inlineDialogBody({onBoardingLink: onBoardingLink});
                content.html($(containerBody).html());
                showPopup();
                return false;
            },
            {
                offsetY: -40,
                offsetX: 15,
                gravity: 'w',
                hideCallback: function () {
                    inlineDialogShow = false;
                }
            }
        );
    }

    function createHotspot() {
        getMenuLink().before($(SAOnBoardingTemplates.hotspot()));
        return getHotspot();
    }

    function markOnBoardingAsShowed() {
        getHotspot().hide();
        JIRA.SmartAjax.makeRequest({
            type: 'POST',
            url: AJS.params.baseURL + '/rest/attach-cat/1.0/settings/onboarding'
        });
    }

    function getProjectKey() {
        return getMenuLink().attr('href').match(/(.+?)(projectKey=)(.*)$/)[3];
    }

    function getHotspot() {
        return $('#sa-hotspot');
    }

    function getMenuLink() {
        return $('#smart-attachments-project');
    }

})(AJS.$);