define('smart-attachments/dnd/upload/Revisions',
    ['jquery', 'underscore', 'exports'],
    function ($, _, exports) {
        var currentMatcher = function () {
        };

        var findRevisionInfo = function (revisionMatcher, file) {
            var found = revisionMatcher(file.categoryId, file.name);
            if (found.length === 1) {
                var info = found[0];
                if (info.documentId) {
                    console.log("Found document for file name:" + file.name);
                } else {
                    console.log("Found parent attachment for name:" + file.name);
                }
                return found[0];
            }
        };

        var matchFilesToAttachmentAsRevisions = function (matcher, files) {
            if (!files.reduce) {
                files.reduce = Array.prototype.reduce;
            }

            var findRevisionInfoForFile = _.partial(findRevisionInfo, matcher);
            var attachmentIdToFiles = files.reduce(function (collector, file) {
                var found = findRevisionInfoForFile(file);
                if (found) {
                    var store = collector[found.attachmentId];
                    if (!store) {
                        store = [];
                        collector[found.attachmentId] = store;
                    }
                    store.push(file);
                }
                return collector;
            }, []);

            var anyMatch = false;

            _.each(attachmentIdToFiles, function (matchedFiles, attachmentId) {
                if (matchedFiles.length === 1) {
                    var file = matchedFiles[0];
                    file.parentAttachmentId = attachmentId;
                    anyMatch = true;
                }
            });
            return anyMatch;
        };

        exports.registerMatcher = function (matcher) {
            if (typeof matcher !== 'function') {
                throw new Error("Matcher must be a function");
            }
            currentMatcher = matcher;
        };

        exports.getMatcher = function () {
            return currentMatcher;
        };

        exports.reset = function () {
            currentMatcher = function () {
            };
        };

        exports.createFilesMatcher = function (matcher) {
            var matcherFn  = matcher || currentMatcher;
            return _.partial(matchFilesToAttachmentAsRevisions, matcherFn);
        }
    });